PiShrink/pishrink.sh

373 lines
9.1 KiB
Bash
Raw Normal View History

2016-04-12 05:05:00 +02:00
#!/bin/bash
version="v0.1.2"
2020-02-07 16:49:22 +01:00
CURRENT_DIR="$(pwd)"
SCRIPTNAME="${0##*/}"
2020-02-07 16:49:22 +01:00
MYNAME="${SCRIPTNAME%.*}"
LOGFILE="${CURRENT_DIR}/${SCRIPTNAME%.*}.log"
REQUIRED_TOOLS="parted losetup tune2fs md5sum e2fsck resize2fs"
2020-02-07 16:49:22 +01:00
ZIPTOOLS=("gzip xz")
declare -A ZIP_PARALLEL_OPTIONS=( [gzip]="-f9" [xz]="-T0" ) # options for zip tools in parallel mode
declare -A ZIPEXTENSIONS=( [gzip]="gz" [xz]="xz" ) # extensions of zipped files
function info() {
2020-02-07 16:49:22 +01:00
echo "$SCRIPTNAME: $1 ..."
}
function error() {
echo -n "$SCRIPTNAME: ERROR occured in line $1: "
shift
echo "$@"
}
2018-02-14 20:05:03 +01:00
function cleanup() {
if losetup "$loopback" &>/dev/null; then
losetup -d "$loopback"
fi
if [ "$debug" = true ]; then
local old_owner=$(stat -c %u:%g "$src")
chown "$old_owner" "$LOGFILE"
fi
2018-02-14 20:05:03 +01:00
}
function logVariables() {
if [ "$debug" = true ]; then
echo "Line $1" >> "$LOGFILE"
shift
local v var
for var in "$@"; do
eval "v=\$$var"
echo "$var: $v" >> "$LOGFILE"
done
fi
}
function checkFilesystem() {
info "Checking filesystem"
e2fsck -pf "$loopback"
(( $? < 4 )) && return
info "Filesystem error detected!"
info "Trying to recover corrupted filesystem"
e2fsck -y "$loopback"
(( $? < 4 )) && return
if [[ $repair == true ]]; then
info "Trying to recover corrupted filesystem - Phase 2"
e2fsck -fy -b 32768 "$loopback"
(( $? < 4 )) && return
fi
error $LINENO "Filesystem recoveries failed. Giving up..."
exit -9
}
help() {
local help
read -r -d '' help << EOM
2020-02-07 16:49:22 +01:00
Usage: $0 [-sdiarpzvh] imagefile.img [newimagefile.img]
-s Don't expand filesystem when image is booted the first time
-d Write debug messages in a debug log file
-r Use advanced filesystem repair option if the normal one fails
-p Remove logs, apt archives, dhcp leases and ssh hostkeys
2020-02-07 16:49:22 +01:00
-v Be verbose
-z Compress image after shrinking
2020-02-07 16:49:22 +01:00
-i TOOL Zip tool to use to compress image. TOOLS can be one of $ZIPTOOLS (Default: gzip)
-a Use parallel compress feature of compression tool
EOM
echo "$help"
exit -1
}
should_skip_autoexpand=false
debug=false
2018-08-19 17:46:55 +02:00
repair=false
compress=false
2020-02-07 16:49:22 +01:00
parallel=false
verbose=false
prep=false
ziptool="gzip"
required_tools="$REQUIRED_TOOLS"
2020-02-07 16:49:22 +01:00
while getopts ":adhipr:svz" opt; do
2016-08-22 10:11:37 +02:00
case "${opt}" in
2020-02-07 16:49:22 +01:00
a) parallel=true;;
d) debug=true;;
2020-02-07 16:49:22 +01:00
h) help;;
i) ziptool="$OPTARG";;
p) prep=true;;
2020-02-07 16:49:22 +01:00
r) repair=true;;
s) should_skip_autoexpand=true ;;
z) compress=true;;
2020-02-07 16:49:22 +01:00
v) verbose=true;;
*) help;;
2016-08-22 10:11:37 +02:00
esac
done
shift $((OPTIND-1))
if [ "$debug" = true ]; then
info "Creating log file $LOGFILE"
rm "$LOGFILE" &>/dev/null
exec 1> >(stdbuf -i0 -o0 -e0 tee -a "$LOGFILE" >&1)
exec 2> >(stdbuf -i0 -o0 -e0 tee -a "$LOGFILE" >&2)
fi
echo "${0##*/} $version"
2016-04-12 05:05:00 +02:00
#Args
src="$1"
2017-12-02 23:18:54 +01:00
img="$1"
2016-04-12 05:05:00 +02:00
#Usage checks
2017-12-02 23:18:54 +01:00
if [[ -z "$img" ]]; then
help
2016-04-12 05:05:00 +02:00
fi
if [[ ! -f "$img" ]]; then
error $LINENO "$img is not a file..."
2016-04-12 05:05:00 +02:00
exit -2
fi
if (( EUID != 0 )); then
error $LINENO "You need to be running as root."
2016-08-22 10:11:37 +02:00
exit -3
2016-04-12 05:05:00 +02:00
fi
# check selected compression tool is supported and installed
if [[ $compress == true ]]; then
if [[ ! " ${ZIPTOOLS[@]} " =~ " $ziptool " ]]; then
error $LINENO "$ziptool is an unsupported ziptool."
exit -17
else
REQUIRED_TOOLS="$REQUIRED_TOOLS $ziptool"
fi
fi
#Check that what we need is installed
for command in $REQUIRED_TOOLS; do
command -v $command >/dev/null 2>&1
2018-01-22 04:05:31 +01:00
if (( $? != 0 )); then
error $LINENO "$command is not installed."
2018-01-22 04:05:31 +01:00
exit -4
fi
done
#Copy to new file if requested
if [ -n "$2" ]; then
info "Copying $1 to $2..."
cp --reflink=auto --sparse=always "$1" "$2"
if (( $? != 0 )); then
error $LINENO "Could not copy file..."
2016-08-22 10:11:37 +02:00
exit -5
fi
old_owner=$(stat -c %u:%g "$1")
chown "$old_owner" "$2"
2017-12-02 23:18:54 +01:00
img="$2"
fi
2018-02-14 20:05:03 +01:00
# cleanup at script exit
trap cleanup ERR EXIT
2016-04-12 05:05:00 +02:00
#Gather info
info "Gathering data"
2020-01-09 13:21:55 +01:00
beforesize="$(ls -lh "$img" | cut -d ' ' -f 5)"
parted_output="$(parted -ms "$img" unit B print | tail -n 1)"
partnum="$(echo "$parted_output" | cut -d ':' -f 1)"
partstart="$(echo "$parted_output" | cut -d ':' -f 2 | tr -d 'B')"
loopback="$(losetup -f --show -o "$partstart" "$img")"
tune2fs_output="$(tune2fs -l "$loopback")"
currentsize="$(echo "$tune2fs_output" | grep '^Block count:' | tr -d ' ' | cut -d ':' -f 2)"
blocksize="$(echo "$tune2fs_output" | grep '^Block size:' | tr -d ' ' | cut -d ':' -f 2)"
2016-04-12 05:05:00 +02:00
2020-01-09 13:21:55 +01:00
logVariables $LINENO beforesize parted_output partnum partstart tune2fs_output currentsize blocksize
#Check if we should make pi expand rootfs on next boot
if [ "$should_skip_autoexpand" = false ]; then
#Make pi expand rootfs on next boot
mountdir=$(mktemp -d)
2018-01-22 03:50:41 +01:00
mount "$loopback" "$mountdir"
if [ "$(md5sum "$mountdir/etc/rc.local" | cut -d ' ' -f 1)" != "0542054e9ff2d2e0507ea1ffe7d4fc87" ]; then
2018-01-22 02:37:05 +01:00
echo "Creating new /etc/rc.local"
2018-01-22 03:50:41 +01:00
mv "$mountdir/etc/rc.local" "$mountdir/etc/rc.local.bak"
#####Do not touch the following lines#####
2020-02-07 16:49:22 +01:00
2018-01-22 03:50:41 +01:00
cat <<\EOF1 > "$mountdir/etc/rc.local"
#!/bin/bash
do_expand_rootfs() {
ROOT_PART=$(mount | sed -n 's|^/dev/\(.*\) on / .*|\1|p')
PART_NUM=${ROOT_PART#mmcblk0p}
if [ "$PART_NUM" = "$ROOT_PART" ]; then
echo "$ROOT_PART is not an SD card. Don't know how to expand"
return 0
fi
# Get the starting offset of the root partition
PART_START=$(parted /dev/mmcblk0 -ms unit s p | grep "^${PART_NUM}" | cut -f 2 -d: | sed 's/[^0-9]//g')
[ "$PART_START" ] || return 1
# Return value will likely be error for fdisk as it fails to reload the
# partition table because the root fs is mounted
fdisk /dev/mmcblk0 <<EOF
p
d
$PART_NUM
n
p
$PART_NUM
$PART_START
p
w
EOF
cat <<EOF > /etc/rc.local &&
#!/bin/sh
echo "Expanding /dev/$ROOT_PART"
resize2fs /dev/$ROOT_PART
rm -f /etc/rc.local; cp -f /etc/rc.local.bak /etc/rc.local; /etc/rc.local
EOF
reboot
exit
}
raspi_config_expand() {
/usr/bin/env raspi-config --expand-rootfs
if [[ $? != 0 ]]; then
return -1
else
rm -f /etc/rc.local; cp -f /etc/rc.local.bak /etc/rc.local; /etc/rc.local
reboot
exit
fi
}
raspi_config_expand
echo "WARNING: Using backup expand..."
sleep 5
do_expand_rootfs
echo "ERROR: Expanding failed..."
sleep 5
rm -f /etc/rc.local; cp -f /etc/rc.local.bak /etc/rc.local; /etc/rc.local
exit 0
EOF1
#####End no touch zone#####
2018-01-22 03:50:41 +01:00
chmod +x "$mountdir/etc/rc.local"
fi
2018-01-22 03:50:41 +01:00
umount "$mountdir"
else
2018-01-22 02:37:05 +01:00
echo "Skipping autoexpanding process..."
fi
2016-04-12 05:05:00 +02:00
if [[ $prep == true ]]; then
info "Syspreping: Removing logs, apt archives, dhcp leases and ssh hostkeys"
mountdir=$(mktemp -d)
mount "$loopback" "$mountdir"
2020-01-09 13:21:55 +01:00
rm -rf "$mountdir/var/cache/apt/archives/*" "$mountdir/var/lib/dhcpcd5/*" "$mountdir/var/log/*" "$mountdir/var/tmp/*" "$mountdir/tmp/*" "$mountdir/etc/ssh/*_host_*"
umount "$mountdir"
fi
#Make sure filesystem is ok
checkFilesystem
if ! minsize=$(resize2fs -P "$loopback"); then
rc=$?
error $LINENO "resize2fs failed with rc $rc"
exit -10
fi
minsize=$(cut -d ':' -f 2 <<< "$minsize" | tr -d ' ')
2020-01-09 13:21:55 +01:00
logVariables $LINENO currentsize minsize
if [[ $currentsize -eq $minsize ]]; then
error $LINENO "Image already shrunk to smallest size"
exit -11
fi
#Add some free space to the end of the filesystem
extra_space=$(($currentsize - $minsize))
logVariables $LINENO extra_space
for space in 5000 1000 100; do
if [[ $extra_space -gt $space ]]; then
minsize=$(($minsize + $space))
break
fi
done
logVariables $LINENO minsize
#Shrink filesystem
info "Shrinking filesystem"
2018-01-22 03:50:41 +01:00
resize2fs -p "$loopback" $minsize
if [[ $? != 0 ]]; then
error $LINENO "resize2fs failed"
2018-01-22 03:50:41 +01:00
mount "$loopback" "$mountdir"
mv "$mountdir/etc/rc.local.bak" "$mountdir/etc/rc.local"
umount "$mountdir"
losetup -d "$loopback"
exit -12
fi
2016-04-12 05:05:00 +02:00
sleep 1
#Shrink partition
partnewsize=$(($minsize * $blocksize))
newpartend=$(($partstart + $partnewsize))
logVariables $LINENO partnewsize newpartend
if ! parted -s -a minimal "$img" rm "$partnum"; then
rc=$?
error $LINENO "parted failed with rc $rc"
exit -13
fi
if ! parted -s "$img" unit B mkpart primary "$partstart" "$newpartend"; then
rc=$?
error $LINENO "parted failed with rc $rc"
exit -14
fi
2016-04-12 05:05:00 +02:00
#Truncate the file
info "Shrinking image"
if ! endresult=$(parted -ms "$img" unit B print free); then
rc=$?
error $LINENO "parted failed with rc $rc"
exit -15
fi
2019-08-23 15:46:45 +02:00
endresult=$(tail -1 <<< "$endresult" | cut -d ':' -f 2 | tr -d 'B')
logVariables $LINENO endresult
if ! truncate -s "$endresult" "$img"; then
rc=$?
error $LINENO "trunate failed with rc $rc"
exit -16
2018-08-19 22:05:28 +02:00
fi
if [[ $compress == true ]]; then
2020-02-07 16:49:22 +01:00
options=""
envVarname="${MYNAME^^}_${ziptool^^}"
if [[ $parallel == true ]]; then
options="${ZIP_PARALLEL_OPTIONS[$ziptool]}"
[[ -v $envVarname ]] && options="${!envVarname}"
[[ $verbose == true ]] && options="$options -v"
info "Using $ziptool on the shrunk image using options ${options}"
if ! $ziptool ${options} "$img"; then
rc=$?
error $LINENO "$ziptool failed with rc $rc"
exit -18
fi
else # sequential
info "Using $ziptool on the shrunk image"
[[ -v $envVarname ]] && options="${!envVarname}"
[[ $verbose == true ]] && options="$options -v"
if ! $ziptool ${options} $img; then
rc=$?
error $LINENO "$ziptool failed with rc $rc"
exit -19
fi
fi
img=$img.${ZIPEXTENSIONS[$ziptool]}
2019-08-27 09:52:43 +02:00
fi
aftersize=$(ls -lh "$img" | cut -d ' ' -f 5)
logVariables $LINENO aftersize
2016-04-12 05:05:00 +02:00
info "Shrunk $img from $beforesize to $aftersize"